rm(list=ls())

# Exercice 2
A <- matrix(c(1,2,-2,
              1,1,1,
              2,2,1),3,3,
            byrow = T)

A <- matrix(c(2,-1,0,
            -1,2,-1,
             0,-1,2),3,3)
b <- rep(1,3)
D <- diag(diag(A))
L <- -lower.tri(A)*A
U <- -upper.tri(A)*A

Tj <- solve(D)%*%(L+U)
x0 <- rep(1,3)
c <- solve(D)%*%b
x1 <- Tj%*%x0 + c
TGS <- solve(D-L)%*%U


# Exercice 3

jacobiGS <- function(A, b, x0, tol, nmax=100, method="Jacobi"){
  n <- nrow(A)
  x0 <- as.matrix(x0)
  D <- diag(diag(A))
  L <- -lower.tri(A)*A
  U <- -upper.tri(A)*A
  if (method == "Jacobi") {
    Dinv <-  diag(1/diag(D))
    Tm <- Dinv%*%(L+U)
    c <- Dinv%*%b
  } else if (method == "relax") {
    omega <- 1
    DmLinv <- solve(D-omega*L)
    Tm <- DmLinv%*%((1-omega)*D + omega*U)
    c <- omega*DmLinv%*%b
  } else if (method == "GS") {
    DmLinv <- solve(D-L)
    Tm <- DmLinv%*%U
    c <- DmLinv%*%b
  } else {
      stop("Methode non reconnue")
  }
  x <- x0
  r0 <- b - A%*%x
  err <- norm(r0, "I")
  iter <- 0
  while (err > tol && iter < nmax){
    iter <- iter + 1
    x <- Tm %*% x + c
    r <- b - A%*%x
    err <- norm(r, "I")
  }
  return(list(x = c(x), iter = iter))
}

jacobiMethod <- function(A, b, x0, tol, nmax) {
  n <- length(b)
  x <- x0
  for (k in 1:nmax) {
    x_new <- as.matrix(numeric(n))
    for (i in 1:n) {
      sum_Ax <- sum(A[i, -i] * x0[-i])
      x_new[i] <- (-sum_Ax + b[i]) / A[i, i]
    }
      if (norm(x_new - x0, "I")/norm(x_new, "I") < tol) {
      return(list(x = c(x_new), iter = k))
    }
    x0 <- x_new
  }
  warning("max num iter atteint")
  return(list(x = c(x_new), iter = nmax))
}

gaussSeidelMethod <- function(A, b, x0, tol, nmax) {
  n <- length(b)
  x <- x0
  for (k in 1:nmax) {
    x_new <- x
    for (i in 1:n) {
      sum_Ax <- sum(A[i, -i] * x_new[-i])
      x_new[i] <- (-sum_Ax + b[i]) / A[i, i]
    }
    if (norm(x_new - x, "I")/norm(x_new, "I") < tol) {
      return(list(x = x_new, iter = k))
    }
    x <- x_new
  }
  warning("max num iter atteint")
  return(list(x = x_new, iter = nmax))
}


uplowdiag <- function(x, k){
  n <- length(x)
  m <- n + abs(k)
  y <- matrix(0, nrow=m, ncol=m)
  y[col(y) == row(y) + k] <- x
  y
} 
An <- function(n){
  sA <- rep(-1, n-1)
  A <- 2*diag(n) + uplowdiag(sA, 1) + uplowdiag(sA, -1)
  A
}

A <- An(100)
b <- x0 <- as.matrix(rep(1,10))
nmax <- 500
tol <- 1e-3
testJ <- jacobiMethod(A,b,x0,tol=tol,nmax=nmax)
testGS <- gaussSeidelMethod(A,b,x0,tol=tol,nmax=nmax)
print(testJ$iter)
print(testGS$iter)



